SystemOrganization addCategory: #'acceptit-GUI'!

LazyListMorph subclass: #ACLazyListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-GUI'!

!ACLazyListMorph methodsFor: 'as yet unclassified' stamp: 'db 7/24/2010 16:54'!
colorForRow: row
	
	^(selectedRow notNil and: [ row = selectedRow])
		ifTrue: [ self class listSelectionTextColor ]
		ifFalse: [ listSource getListItemColorAt: row ].! !

PluggableListMorphPlus subclass: #ACPluggableListMorphPlus
	instanceVariableNames: 'getListItemColorSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-GUI'!

!ACPluggableListMorphPlus methodsFor: 'as yet unclassified' stamp: 'db 7/24/2010 16:57'!
getListItemColorAt: anIndex

	^ getListItemColorSelector 
		ifNotNil: [ self model perform: getListItemColorSelector withArguments: {anIndex}]
		ifNil: [ self halt Color black ]! !

!ACPluggableListMorphPlus methodsFor: 'as yet unclassified' stamp: 'db 7/24/2010 16:43'!
getListItemColorSelector

	^ getListItemColorSelector! !

!ACPluggableListMorphPlus methodsFor: 'as yet unclassified' stamp: 'db 7/24/2010 16:43'!
getListItemColorSelector: aSymbol
	getListItemColorSelector := aSymbol! !

!ACPluggableListMorphPlus methodsFor: 'as yet unclassified' stamp: 'db 7/22/2010 02:13'!
listMorphClass
	^ACLazyListMorph! !

TestRunner subclass: #ACTestRunner
	instanceVariableNames: 'scenariosSelected scenarios scenarioIndex stepSelected stepIndex stepColors showUserStory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-GUI'!

ACTestRunner class
	instanceVariableNames: 'colors'!

ACTestRunner class
	instanceVariableNames: 'colors'!

!ACTestRunner class methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 13:47'!
colors

	^ colors ifNil: [colors := IdentityDictionary new
		at: #passed put: Color green muchDarker;
		at: #failed put: Color yellow muchDarker;
		at: #error put: Color red muchDarker;
		at: #skipped put: Color blue muchDarker;
		at: #default put: Color black;
		yourself]! !

!ACTestRunner class methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 17:40'!
listForParseTree: aParseTree
	
	| pureTree verbTree list max |
	max := 0.
	"format tests"
	(aParseTree first ~= #annotated) ifTrue: [^ {}].
	pureTree := aParseTree second.
	(pureTree first ~= #scenario) ifTrue: [^ {}].
	(pureTree second first ~= #title) ifTrue: [^ {}].
	"actual."
	verbTree := pureTree allButFirst: 2.
	verbTree do: [ :verbArray |
		verbArray allButFirst do: [:assoc | 
			max := max max: assoc key]].
	list := Array new: max.
	verbTree do: [ :verbArray | | verb |
		verb := verbArray first.
		verbArray allButFirst do: [:assoc | 
			list at: assoc key put: verb -> assoc value]].

	^ list

! !

!ACTestRunner class methodsFor: 'as yet unclassified' stamp: 'db 7/22/2010 02:36'!
open
	^ ACMorphicToolBuilder new open: self new.! !

!ACTestRunner class methodsFor: 'as yet unclassified' stamp: 'db 7/19/2010 16:59'!
registerInToolsFlap
	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: #( ACTestRunner build 'Scenario Runner' 'A production scale test-runner.' ) forFlapNamed: 'Tools';
			replaceToolsFlap ].! !

!ACTestRunner class methodsFor: 'as yet unclassified' stamp: 'db 7/20/2010 14:26'!
registerInWorldMenu

	self environment at: #TheWorldMenu ifPresent: [ :class |
		class registerOpenCommand: (Array 
			with: 'Scenario Runner' 
			with: (Array
				with: self
				with: #open)) ].! !

!ACTestRunner class methodsFor: 'as yet unclassified' stamp: 'db 7/19/2010 16:53'!
windowColorSpecification

	^ WindowColorSpec 
		classSymbol: self name 
		wording: 'Accept It Scenario Runner' 
		brightColor:  Color blue
		pastelColor: (Color r: 0.65 g: 0.753 b: 0.976)
		helpMessage: 'Smalltalk TestRunner tool for AcceptIt User Stories'! !

!ACTestRunner methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 17:29'!
arrayForParseTree: aParseTree
	
	| pureTree|
	"format tests"
	(aParseTree first ~= #annotated) ifTrue: [^ {}].
	pureTree := aParseTree second.
	(pureTree first ~= #scenario) ifTrue: [^ {}].
	(pureTree second first ~= #title) ifTrue: [^ {}].
	"actual."
	


 {#annotated . 
	{#scenario . #(#title 'Hello World Test') . 
	{#given . 2->'I have a web site'} . 
	{#when . 3->'I go to the web site' . 4->'I go to the web site'} . 
	{#then . 5->'I see "Hello World"' . 6->'I see "Hello World"'}}}! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/19/2010 15:14'!
baseClass

	^ ACUserStory! !

!ACTestRunner methodsFor: 'utilities' stamp: 'topa 2/14/2011 09:13'!
browseToStepImplementation

	|  step parsedScenario linesWithPrefix sc |
	
	stepIndex < 3 ifTrue:[^nil]."no browsing for title and empty line"
	
	sc := scenarios at: scenarioIndex.
	parsedScenario := ACUSParser matchAll: (( sc class compiledMethodAt: sc selector) getSource) readStream with: #scenario withArgs: #().
	
	linesWithPrefix := OrderedCollection new.
	
	(parsedScenario allButFirst: 2) do: [:arr | 
		arr do: [:item | 
			item isSymbol ifFalse:[linesWithPrefix add: {arr at: 1. item}]]]. 
	
	step := sc
		methodForVerb: ((linesWithPrefix at: stepIndex - 2) at: 1)
		andStep:  ((linesWithPrefix at: stepIndex - 2) at: 2) asString.
	
	self systemNavigation browseAllImplementorsOf: step selector localTo: step methodClass .
	
		

! !

!ACTestRunner methodsFor: 'building' stamp: 'db 7/20/2010 01:30'!
buildScenariosWith: aBuilder

	^ aBuilder pluggableMultiSelectionListSpec new
		model: self;
		list: #scenarioList;
		menu: #scenarioMenu:;
		getIndex: #scenarioSelected;
		setIndex: #scenarioSelected:;
		getSelectionList: #scenarioAt:;
		setSelectionList: #scenarioAt:put:;
		yourself.! !

!ACTestRunner methodsFor: 'building' stamp: 'topa 11/2/2010 18:44'!
buildStepsWith: aBuilder

	^ aBuilder pluggableACListSpec new
		model: self;
		list: #stepList;
		menu: #stepMenu:;
		getIndex: #stepSelected;
		setIndex: #stepSelected:;
		getListItemColor: #stepColorAt:;
		doubleClick: #browseToStepImplementation
		yourself.! !

!ACTestRunner methodsFor: 'building' stamp: 'db 7/20/2010 02:38'!
buildWith: aBuilder

	| window |
	window := aBuilder pluggableWindowSpec new
		model: self; label: self label; extent: self extent;
		children: (OrderedCollection new 
			add: ((self buildClassesWith: aBuilder)
				frame: (0.00 @ 0.00 corner: 0.25 @ 0.92 );
				yourself);
			add: ((self buildScenariosWith: aBuilder)
				frame: (0.25 @ 0.00 corner: 0.50 @ 0.92 );
				yourself);
			add: ((self buildStatusWith: aBuilder)
				frame: (0.50 @ 0.00 corner: 1.00 @ 0.08);
				yourself);
			add: ((self buildStepsWith: aBuilder)
				frame: (0.50 @ 0.08 corner: 1.00 @ 0.50);
				yourself);
			add: ((self buildFailureListWith: aBuilder)
				frame: (0.50 @ 0.50 corner: 1.00 @ 0.71);
				yourself);
			add: ((self buildErrorListWith: aBuilder)
				frame: (0.50 @ 0.71 corner: 1.00 @ 0.92);
				yourself);
			add: ((self buildButtonsWith: aBuilder)
				frame: (0.00 @ 0.92 corner: 1.00 @ 1.00);
				yourself);
			yourself);
		yourself.
	^ aBuilder build: window.! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/21/2010 17:39'!
classAt: anInteger put: aBoolean
	classesSelected := classesSelected
		perform: (aBoolean ifTrue: [ #copyWith: ] ifFalse: [ #copyWithout: ])
		with: (classes at: anInteger ifAbsent: [^ self ]).
		self updateScenarios.
	self changed: #classSelected; changed: #updateScenarios; changed: #hasRunnable.! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/21/2010 17:18'!
classSelected: anInteger
	
	classIndex := anInteger.
	showUserStory := true.
	
	self changed: #classSelected; changed: #stepList. "; changed: #updateScenarios ."
	! !

!ACTestRunner methodsFor: 'utilities' stamp: 'db 7/21/2010 15:56'!
findClassesForCategories: aCollection

	aCollection isEmpty 
		ifTrue: [ ^ self baseClass subclasses asSet ].
	! !

!ACTestRunner methodsFor: 'utilities' stamp: 'topa 9/23/2010 12:20'!
findScenariosForClasses: aCollection

	aCollection isEmpty 
		ifTrue: [  ^{}].
	^ aCollection inject: Set new into: [ :set :class | 
		class allTestSelectors do: [:selector | set add: (class selector: selector)].
		set]! !

!ACTestRunner methodsFor: 'updating' stamp: 'db 7/21/2010 15:33'!
initialize

	super initialize.
	showUserStory:= true.! !

!ACTestRunner methodsFor: 'accessing-ui' stamp: 'db 7/19/2010 18:29'!
label

	^ 'Accept It Scenario Runner'! !

!ACTestRunner methodsFor: 'updating' stamp: 'db 10/5/2010 05:24'!
reset
	self result: ACScenarioResult new; updateResults.! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/20/2010 01:31'!
scenarioAt: anIndex

	^ scenariosSelected includes: (scenarios at: anIndex ifAbsent: [ ^ false ]).! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/21/2010 19:33'!
scenarioAt: anInteger put: aBoolean

	scenariosSelected := scenariosSelected
		perform: (aBoolean ifTrue: [ #copyWith: ] ifFalse: [ #copyWithout: ])
		with: (scenarios at: anInteger ifAbsent: [ ^ self ]).
			
	self updateSteps.! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/21/2010 17:08'!
scenarioList

	^ scenarios! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/20/2010 01:31'!
scenarioMenu: aMenu

	^ aMenu
		title: 'Scenarios'.
		"add: 'Select all' action: #selectAllCategories;
		add: 'Select inversion' action: #selectInverseCategories;
		add: 'Select none' action: #selectNoCategories;
		addLine;
		add: 'Filter...' action: #filterCategories;
		addLine;
		add: 'Refresh' action: #updateCategories;
		yourself."! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/20/2010 01:31'!
scenarioSelected

	^ scenarioIndex! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/21/2010 15:21'!
scenarioSelected: anInteger

	scenarioIndex := anInteger.
	showUserStory := false.
	self changed: #scenarioSelected.! !

!ACTestRunner methodsFor: 'accessing' stamp: 'topa 3/11/2011 17:55'!
stepColorAt: anIndex

	| failBlock |
	failBlock := [^ self class colors at: #default].

	^ showUserStory 
		ifTrue:[Color black]
		ifFalse:[ |scenario status statuus |
			scenario := scenarios at: scenarioIndex.
			statuus := result stepStatus at: scenario ifAbsent: failBlock.
			status := (statuus includes: #all) 
				ifTrue: [statuus at: #all] "fallback, eg errors in setup"
				ifFalse: [|source pt sourceId |
					source := scenario testMethodSource asString.
					pt := [ACUSAnnotatedParser scenarioParseTree: source readStream] on: OM2Fail do: failBlock.		
					sourceId := (self class listForParseTree: pt) at: anIndex ifAbsent: failBlock.
					statuus at: sourceId  ifAbsent: failBlock].
			self class colors at: status ifAbsent: failBlock]! !

!ACTestRunner methodsFor: 'accessing' stamp: 'topa 11/2/2010 19:23'!
stepList
	^ showUserStory 
		ifTrue:[ (classIndex = 0) ifTrue: [{}] ifFalse:[(classes at: classIndex) userStoryString lines]]
		ifFalse:[
			scenarioIndex = 0
				ifTrue:[{}]
				ifFalse:[ |sc|
					sc := (scenarios at: scenarioIndex).
					(sc class compiledMethodAt: sc selector) getSource asString lines]]
		
	
			
	
! !

!ACTestRunner methodsFor: 'accessing' stamp: 'topa 11/2/2010 18:44'!
stepMenu: aMenu

	^ aMenu
		title: 'Steps'.
		"add: 'Select all' action: #selectAllCategories;
		add: 'Select inversion' action: #selectInverseCategories;
		add: 'Select none' action: #selectNoCategories;
		addLine;
		add: 'Filter...' action: #filterCategories;
		addLine;
		add: 'Refresh' action: #updateCategories;
		yourself."! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/24/2010 16:23'!
stepSelected
	
	^ stepIndex = nil 
		ifTrue:[ 0 ]
		ifFalse:[ stepIndex ]! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/21/2010 00:56'!
stepSelected: anInteger

	stepIndex := anInteger.
	self changed: #stepSelected.! !

!ACTestRunner methodsFor: 'building' stamp: 'db 10/5/2010 05:11'!
suiteAll
	^ ACTestSuite new in: [ :suite |
			suite addTests: scenariosSelected.
			suite name: (self label: 'Test' forSuite: suite) ].! !

!ACTestRunner methodsFor: 'updating' stamp: 'db 7/20/2010 03:02'!
update

	super update.
	self updateScenarios; updateSteps! !

!ACTestRunner methodsFor: 'updating' stamp: 'db 7/21/2010 17:40'!
updateScenarios

	| scenariosForClasses |
	scenariosForClasses := self findScenariosForClasses: classesSelected.
	scenarios := scenariosForClasses asArray
		sort: [ :a :b | a printString <= b printString ].
	scenarioIndex := 0.
	scenariosSelected := scenariosSelected isNil
		ifTrue: [ scenariosForClasses ]
		ifFalse: [ 
			scenariosSelected
				select: [ :each | scenariosForClasses includes: each ] ].
	self changed: #scenarioList; changed: #scenarioSelected; changed: #hasRunnable.
! !

!ACTestRunner methodsFor: 'updating' stamp: 'db 7/20/2010 14:27'!
updateSteps

	self changed: #stepList


	! !

MorphicToolBuilder subclass: #ACMorphicToolBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-GUI'!

!ACMorphicToolBuilder class methodsFor: 'as yet unclassified' stamp: 'db 7/22/2010 03:06'!
isActiveBuilder
	"Answer whether I am the currently active builder"
	^false! !

!ACMorphicToolBuilder methodsFor: 'as yet unclassified' stamp: 'db 7/24/2010 16:55'!
buildACPluggableList: aSpec
	| widget listClass getIndex setIndex |
	aSpec getSelected ifNil:[
		listClass := ACPluggableListMorphPlus.
		getIndex := aSpec getIndex.
		setIndex := aSpec setIndex.
	] ifNotNil:[
		listClass := self listByItemClass.
		getIndex := aSpec getSelected.
		setIndex := aSpec setSelected.
	].
	widget := listClass on: aSpec model
				list: aSpec list
				selected: getIndex
				changeSelected: setIndex
				menu: aSpec menu
				keystroke: aSpec keyPress.
	self register: widget id: aSpec name.
	widget getListElementSelector: aSpec listItem.
	widget getListItemColorSelector: aSpec getListItemColor.
	widget getListSizeSelector: aSpec listSize.
	widget doubleClickSelector: aSpec doubleClick.
	widget dragItemSelector: aSpec dragItem.
	widget dropItemSelector: aSpec dropItem.
	widget wantsDropSelector: aSpec dropAccept.
	widget autoDeselect: aSpec autoDeselect.
	widget keystrokePreviewSelector: aSpec keystrokePreview.
	aSpec color isNil ifFalse: [widget color: aSpec color].
	self buildHelpFor: widget spec: aSpec. 
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	panes ifNotNil:[
		aSpec list ifNotNil:[panes add: aSpec list].
	].
	^widget! !

!ACMorphicToolBuilder methodsFor: 'as yet unclassified' stamp: 'db 7/22/2010 03:32'!
pluggableACListSpec
	
	^ ACPluggableListSpec! !

PluggableListSpec subclass: #ACPluggableListSpec
	instanceVariableNames: 'getListItemColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-GUI'!

!ACPluggableListSpec methodsFor: 'as yet unclassified' stamp: 'db 7/22/2010 03:32'!
buildWith: builder
	^builder buildACPluggableList: self! !

!ACPluggableListSpec methodsFor: 'as yet unclassified' stamp: 'db 7/24/2010 16:39'!
getListItemColor

	^ getListItemColor ! !

!ACPluggableListSpec methodsFor: 'as yet unclassified' stamp: 'db 7/24/2010 16:38'!
getListItemColor: aSymbol
	"Set the selector to get the item color"
	getListItemColor := aSymbol.
	! !
